#!/usr/bin/env bash
#
# GitHub Actions Scripts
# Copyright (C) 2021-2023 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

# Bash options:
set -e

DIRNAME=`dirname $0`
UNAME=`uname`
if [ "${UNAME}" == "Linux" ] ; then
   DISTRIBUTION=`lsb_release -is`
else
   DISTRIBUTION="Unknown"
fi


# ###### Linux ##############################################################
if [ "${UNAME}" == "Linux" ] ; then

   # ====== Ubuntu ==========================================================
   if [ "${DISTRIBUTION}" == "Ubuntu" ] ; then
      DEBIAN_FRONTEND=noninteractive ${DIRNAME}/get-dependencies ubuntu --install

   # ====== Debian ==========================================================
   elif [ "${DISTRIBUTION}" == "Debian" ] ; then
      DEBIAN_FRONTEND=noninteractive ${DIRNAME}/get-dependencies debian --install

   # ====== Fedora ==========================================================
   elif [ "${DISTRIBUTION}" == "Fedora" ] ; then
      ${DIRNAME}/get-dependencies fedora --install

   # ====== Unknown =========================================================
   else
      echo >&2 "ERROR: Unknown Linux distribution ${DISTRIBUTION}!"
      exit 1
   fi

# ###### FreeBSD ############################################################
elif [ "${UNAME}" == "FreeBSD" ] ; then

   ${DIRNAME}/get-dependencies freebsd --install

# ###### Unknown ############################################################
else

   echo >&2 "ERROR: Unexpected system ${UNAME}!"
   exit 1

fi
